#!/bin/sh
set -x

echo "S51" > /proc/gpio

#workaroud input/output error
cp /bin/busybox /var/

FW_PATH="/var/tmp/fw"
FW_BIN="$FW_PATH"/fw.bin
FW_BOOT="$FW_PATH"/boot.bin
#FW_CFG="$FW_PATH"/config.json
FMW_BOARD_TYPE="$(cat $FW_PATH/board)"
FACTORY_CUT="$(factory | cut -d':' -f2)"
MODEL_NAME="$(echo $FACTORY_CUT | cut -d' ' -f1)"

echo $MODEL_NAME

UpgradeComplite=0
UpgradeError=1
UpgradeInProgress=2

#if [ "$FMW_BOARD_TYPE" != "$MODEL_NAME" ]; then
#    echo "UPDATE FAIL: board is $MODEL_NAME, but firmware is $FMW_BOARD_TYPE"
#    echo "S50" > /proc/gpio
#    exit 2
#fi

chmod 777 "$FW_PATH"/upgrade-bin
#new_mib_lib="$FW_PATH/lib/apmib/"
#property_lib="$FW_PATH/lib/property/"

UPGRADE_OPTS=""

version=$(cat /etc/build)
major=$(echo $version|cut -d'.' -f 1)
minor=$(echo $version|cut -d'.' -f 2)

if [ $major -eq 1 ]; then
    if [ $minor -le 8 ]; then
        if [ -f "$FW_BOOT" ]; then
            md5_cur=$(busybox md5sum "$FW_PATH"/boot.bin | cut -d' ' -f 1)
            md5_img=$(cat "$FW_PATH"/boot.md5)
            if [ "$md5_cur" != "$md5_img" ]; then
                echo "UPGRADE FAIL: Incorrect boot CRC"
                echo "S50" > /proc/gpio
                exit 3
            fi
            UPGRADE_OPTS="$UPGRADE_OPTS -b $FW_BOOT"

#            echo "Upgrade boot started"
#            "$FW_PATH"/upgrade-bin $UPGRADE_OPTS
#            RETVAL=$?
            board_info -e
            board_info -l "$md5_img"
            #update board info
#            [ "$RETVAL" == "$UpgradeComplite" ] && board_info -l "$md5_img"
        fi
    fi
fi


if [ -f $FW_BIN ]; then
    md5_cur=$(busybox md5sum "$FW_PATH"/fw.bin | cut -d' ' -f 1)
    md5_img=$(cat "$FW_PATH"/fw.md5)
    if [ "$md5_cur" != "$md5_img" ]; then
        echo "UPGRADE FAIL: Incorrect fw CRC"
	echo "S50" > /proc/gpio
        exit 4
    fi
    UPGRADE_OPTS="$UPGRADE_OPTS -f $FW_BIN -d"
fi

echo "Upgrade firmware started"

ver_img=$(cat "$FW_PATH"/version)
board_info -v "$ver_img"
board_info -b "$md5_img"

"$FW_PATH"/upgrade-bin $UPGRADE_OPTS
RETVAL=$?

#update board info
#[ "$RETVAL" == "$UpgradeComplite" ] && { 

#}

if [ "$RETVAL" != "$UpgradeComplite" ]; then
    if [ "$RETVAL" = "$UpgradeInProgress" ]; then
        echo "UPGRADE FAIL: upgrade process is already in progress"
        exit 5
    fi
    echo "UPGRADE FAIL: Error at read/write operation ($RETVAL != $UpgradeComplite)"
    echo "S50" > /proc/gpio
    exit 6
fi

#if [ -f $FW_CFG ]; then
#    # first read default setting's from json to property
#    LD_LIBRARY_PATH="$new_mib_lib:$property_lib" $FW_PATH/property --cur_json "$FW_PATH"/config.json
#    LD_LIBRARY_PATH="$new_mib_lib:$property_lib" $FW_PATH/property --def_json "$FW_PATH"/config.json
#    LD_LIBRARY_PATH="$new_mib_lib:$property_lib" $FW_PATH/property --hw_json "$FW_PATH"/hw_config.json

#if [ -f "$FW_PATH/customer" ]; then
#    CUSTOMER="$(cat $FW_PATH/customer)"
#    echo $CUSTOMER
#    if [ -f "$FW_PATH/$CUSTOMER"/patch.json ]; then
#        LD_LIBRARY_PATH="$new_mib_lib:$property_lib" $FW_PATH/property --cur_json "$FW_PATH/$CUSTOMER"/patch.json
#        LD_LIBRARY_PATH="$new_mib_lib:$property_lib" $FW_PATH/property --def_json "$FW_PATH/$CUSTOMER"/patch.json
#    fi
#    if [ -f "$FW_PATH/$CUSTOMER"/hw_patch.json ]; then
#        LD_LIBRARY_PATH="$new_mib_lib:$property_lib" $FW_PATH/property --hw_json "$FW_PATH/$CUSTOMER"/hw_patch.json
#    fi
#fi

#if [ ! -f "$FW_PATH"/wipe_config ]; then
#    # read previous current setting from old apmib library (for overwriting default settings)
#    # $new_mib_lib not used
#    LD_LIBRARY_PATH="$property_lib" $FW_PATH/property --from_cur
#    LD_LIBRARY_PATH="$property_lib" $FW_PATH/property --from_hw
#fi

    # update apmib tables from property
#    LD_LIBRARY_PATH="$new_mib_lib:$property_lib" $FW_PATH/property --to_def
#    LD_LIBRARY_PATH="$new_mib_lib:$property_lib" $FW_PATH/property --to_cur
#    LD_LIBRARY_PATH="$new_mib_lib:$property_lib" $FW_PATH/property --to_hw
#fi

echo "UPGRADE SUCCESSFULL"

# for old rom compatibility
#cat /bin/upgrade_fw.sh | grep "# version 1.01" > /dev/null
if [ $? != "0" ]; then
    reboot

    #workaroud input/output error
    /var/busybox reboot
    if [ $? != "0" ]; then
        killall -9 timelycheck watchdog
    fi
fi
echo "S50" > /proc/gpio
exit $UpgradeComplite
